/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 74 "src/parse.yy"


#include "ispc.h"
#include "type.h"
#include "module.h"
#include "decl.h"
#include "expr.h"
#include "sym.h"
#include "stmt.h"
#include "util.h"

#include <stdio.h>
#include <llvm/IR/Constants.h>

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static const char *lGetStorageClassString(StorageClass sc);
static bool lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage);
static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float", "for", "foreach", "foreach_active", "foreach_tiled",
     "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = NULL, Expr *b = NULL, Expr *e = NULL) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 142 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_ISPC_1_13_0_BUILD_PARSE_HH_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_ISPC_1_13_0_BUILD_PARSE_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
#line 42 "src/parse.yy"


#define yytnamerr lYYTNameErr


#define YYLTYPE SourcePos

# define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                 \
      if (N)                                                           \
        {                                                              \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;       \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;     \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;        \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;      \
          (Current).name         = YYRHSLOC (Rhs, 1).name    ;         \
        }                                                              \
      else                                                             \
        { /* empty RHS */                                              \
          (Current).first_line   = (Current).last_line   =             \
            YYRHSLOC (Rhs, 0).last_line;                               \
          (Current).first_column = (Current).last_column =             \
            YYRHSLOC (Rhs, 0).last_column;                             \
          (Current).name = NULL;                        /* new */ \
        }                                                              \
    while (0)

struct ForeachDimension;


#line 216 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOKEN_INT8_CONSTANT = 258,
    TOKEN_UINT8_CONSTANT = 259,
    TOKEN_INT16_CONSTANT = 260,
    TOKEN_UINT16_CONSTANT = 261,
    TOKEN_INT32_CONSTANT = 262,
    TOKEN_UINT32_CONSTANT = 263,
    TOKEN_INT64_CONSTANT = 264,
    TOKEN_UINT64_CONSTANT = 265,
    TOKEN_INT32DOTDOTDOT_CONSTANT = 266,
    TOKEN_UINT32DOTDOTDOT_CONSTANT = 267,
    TOKEN_INT64DOTDOTDOT_CONSTANT = 268,
    TOKEN_UINT64DOTDOTDOT_CONSTANT = 269,
    TOKEN_FLOAT_CONSTANT = 270,
    TOKEN_DOUBLE_CONSTANT = 271,
    TOKEN_STRING_C_LITERAL = 272,
    TOKEN_IDENTIFIER = 273,
    TOKEN_STRING_LITERAL = 274,
    TOKEN_TYPE_NAME = 275,
    TOKEN_NULL = 276,
    TOKEN_PTR_OP = 277,
    TOKEN_INC_OP = 278,
    TOKEN_DEC_OP = 279,
    TOKEN_LEFT_OP = 280,
    TOKEN_RIGHT_OP = 281,
    TOKEN_LE_OP = 282,
    TOKEN_GE_OP = 283,
    TOKEN_EQ_OP = 284,
    TOKEN_NE_OP = 285,
    TOKEN_AND_OP = 286,
    TOKEN_OR_OP = 287,
    TOKEN_MUL_ASSIGN = 288,
    TOKEN_DIV_ASSIGN = 289,
    TOKEN_MOD_ASSIGN = 290,
    TOKEN_ADD_ASSIGN = 291,
    TOKEN_SUB_ASSIGN = 292,
    TOKEN_LEFT_ASSIGN = 293,
    TOKEN_RIGHT_ASSIGN = 294,
    TOKEN_AND_ASSIGN = 295,
    TOKEN_OR_ASSIGN = 296,
    TOKEN_XOR_ASSIGN = 297,
    TOKEN_SIZEOF = 298,
    TOKEN_NEW = 299,
    TOKEN_DELETE = 300,
    TOKEN_IN = 301,
    TOKEN_EXTERN = 302,
    TOKEN_EXPORT = 303,
    TOKEN_STATIC = 304,
    TOKEN_INLINE = 305,
    TOKEN_NOINLINE = 306,
    TOKEN_TASK = 307,
    TOKEN_DECLSPEC = 308,
    TOKEN_UNIFORM = 309,
    TOKEN_VARYING = 310,
    TOKEN_TYPEDEF = 311,
    TOKEN_SOA = 312,
    TOKEN_UNMASKED = 313,
    TOKEN_CHAR = 314,
    TOKEN_INT = 315,
    TOKEN_SIGNED = 316,
    TOKEN_UNSIGNED = 317,
    TOKEN_FLOAT = 318,
    TOKEN_DOUBLE = 319,
    TOKEN_INT8 = 320,
    TOKEN_INT16 = 321,
    TOKEN_INT64 = 322,
    TOKEN_CONST = 323,
    TOKEN_VOID = 324,
    TOKEN_BOOL = 325,
    TOKEN_UINT8 = 326,
    TOKEN_UINT16 = 327,
    TOKEN_UINT = 328,
    TOKEN_UINT64 = 329,
    TOKEN_ENUM = 330,
    TOKEN_STRUCT = 331,
    TOKEN_TRUE = 332,
    TOKEN_FALSE = 333,
    TOKEN_CASE = 334,
    TOKEN_DEFAULT = 335,
    TOKEN_IF = 336,
    TOKEN_ELSE = 337,
    TOKEN_SWITCH = 338,
    TOKEN_WHILE = 339,
    TOKEN_DO = 340,
    TOKEN_LAUNCH = 341,
    TOKEN_FOREACH = 342,
    TOKEN_FOREACH_TILED = 343,
    TOKEN_FOREACH_UNIQUE = 344,
    TOKEN_FOREACH_ACTIVE = 345,
    TOKEN_DOTDOTDOT = 346,
    TOKEN_FOR = 347,
    TOKEN_GOTO = 348,
    TOKEN_CONTINUE = 349,
    TOKEN_BREAK = 350,
    TOKEN_RETURN = 351,
    TOKEN_CIF = 352,
    TOKEN_CDO = 353,
    TOKEN_CFOR = 354,
    TOKEN_CWHILE = 355,
    TOKEN_SYNC = 356,
    TOKEN_PRINT = 357,
    TOKEN_ASSERT = 358
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 146 "src/parse.yy"

    uint64_t intVal;
    float  floatVal;
    double doubleVal;
    std::string *stringVal;
    const char *constCharPtr;

    Expr *expr;
    ExprList *exprList;
    const Type *type;
    std::vector<std::pair<const Type *, SourcePos> > *typeList;
    const AtomicType *atomicType;
    int typeQualifier;
    StorageClass storageClass;
    Stmt *stmt;
    DeclSpecs *declSpecs;
    Declaration *declaration;
    std::vector<Declarator *> *declarators;
    std::vector<Declaration *> *declarationList;
    Declarator *declarator;
    std::vector<Declarator *> *structDeclaratorList;
    StructDeclaration *structDeclaration;
    std::vector<StructDeclaration *> *structDeclarationList;
    const EnumType *enumType;
    Symbol *symbol;
    std::vector<Symbol *> *symbolList;
    ForeachDimension *foreachDimension;
    std::vector<ForeachDimension *> *foreachDimensionList;
    std::pair<std::string, SourcePos> *declspecPair;
    std::vector<std::pair<std::string, SourcePos> > *declspecList;

#line 363 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_ISPC_1_13_0_BUILD_PARSE_HH_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  80
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3458

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  128
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  106
/* YYNRULES -- Number of rules.  */
#define YYNRULES  342
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  646

#define YYUNDEFTOK  2
#define YYMAXUTOK   358


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   117,     2,     2,     2,   119,   112,     2,
     104,   105,   113,   114,   108,   115,   111,   118,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   123,   125,
     109,   124,   110,   122,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   106,     2,   107,   120,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   126,   121,   127,   116,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   265,   265,   266,   275,   294,   298,   302,   306,   310,
     314,   318,   322,   326,   330,   334,   337,   340,   345,   346,
     350,   356,   363,   369,   376,   382,   388,   394,   401,   406,
     411,   416,   423,   429,   435,   441,   450,   451,   453,   455,
     456,   458,   460,   462,   467,   468,   470,   472,   477,   478,
     492,   493,   495,   497,   499,   501,   503,   505,   507,   509,
     511,   516,   517,   524,   525,   527,   529,   534,   535,   537,
     542,   543,   545,   550,   551,   553,   555,   557,   562,   563,
     565,   570,   571,   576,   577,   582,   583,   588,   589,   594,
     595,   600,   601,   606,   607,   608,   612,   613,   624,   635,
     659,   660,   664,   668,   675,   676,   678,   680,   682,   684,
     686,   688,   690,   692,   694,   696,   701,   702,   707,   711,
     737,   741,   748,   753,   763,   768,   777,   784,   788,   802,
     808,   818,   824,   835,   839,   845,   863,   867,   877,   884,
     898,   899,   908,   909,   910,   911,   915,   916,   921,   922,
     926,   937,   948,   949,   950,   951,   952,   953,   954,   955,
     956,   957,   958,   959,   963,   970,   971,   975,   997,   998,
    1017,  1031,  1039,  1056,  1060,  1067,  1081,  1086,  1087,  1088,
    1089,  1165,  1172,  1186,  1194,  1197,  1201,  1205,  1209,  1213,
    1236,  1246,  1260,  1264,  1280,  1281,  1282,  1283,  1284,  1285,
    1286,  1287,  1288,  1289,  1293,  1297,  1304,  1316,  1328,  1332,
    1333,  1334,  1335,  1339,  1345,  1349,  1367,  1378,  1382,  1394,
    1404,  1412,  1416,  1422,  1428,  1439,  1447,  1451,  1458,  1467,
    1475,  1479,  1488,  1495,  1512,  1513,  1525,  1529,  1530,  1540,
    1544,  1557,  1559,  1565,  1582,  1593,  1611,  1613,  1619,  1629,
    1643,  1644,  1645,  1649,  1651,  1665,  1666,  1667,  1668,  1669,
    1670,  1671,  1672,  1673,  1674,  1675,  1676,  1677,  1685,  1689,
    1699,  1704,  1708,  1712,  1713,  1717,  1723,  1736,  1737,  1741,
    1743,  1745,  1747,  1749,  1754,  1756,  1761,  1762,  1766,  1770,
    1774,  1778,  1782,  1789,  1793,  1800,  1804,  1808,  1812,  1819,
    1823,  1830,  1835,  1849,  1853,  1857,  1859,  1861,  1863,  1865,
    1869,  1873,  1877,  1882,  1881,  1910,  1909,  1939,  1938,  1950,
    1948,  1969,  1973,  1975,  1977,  1979,  1981,  1986,  1991,  1998,
    2005,  2009,  2016,  2023,  2024,  2025,  2029,  2030,  2031,  2036,
    2042,  2047,  2046
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT_CONSTANT",
  "TOKEN_DOUBLE_CONSTANT", "TOKEN_STRING_C_LITERAL", "TOKEN_IDENTIFIER",
  "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME", "TOKEN_NULL", "TOKEN_PTR_OP",
  "TOKEN_INC_OP", "TOKEN_DEC_OP", "TOKEN_LEFT_OP", "TOKEN_RIGHT_OP",
  "TOKEN_LE_OP", "TOKEN_GE_OP", "TOKEN_EQ_OP", "TOKEN_NE_OP",
  "TOKEN_AND_OP", "TOKEN_OR_OP", "TOKEN_MUL_ASSIGN", "TOKEN_DIV_ASSIGN",
  "TOKEN_MOD_ASSIGN", "TOKEN_ADD_ASSIGN", "TOKEN_SUB_ASSIGN",
  "TOKEN_LEFT_ASSIGN", "TOKEN_RIGHT_ASSIGN", "TOKEN_AND_ASSIGN",
  "TOKEN_OR_ASSIGN", "TOKEN_XOR_ASSIGN", "TOKEN_SIZEOF", "TOKEN_NEW",
  "TOKEN_DELETE", "TOKEN_IN", "TOKEN_EXTERN", "TOKEN_EXPORT",
  "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE", "TOKEN_TASK",
  "TOKEN_DECLSPEC", "TOKEN_UNIFORM", "TOKEN_VARYING", "TOKEN_TYPEDEF",
  "TOKEN_SOA", "TOKEN_UNMASKED", "TOKEN_CHAR", "TOKEN_INT", "TOKEN_SIGNED",
  "TOKEN_UNSIGNED", "TOKEN_FLOAT", "TOKEN_DOUBLE", "TOKEN_INT8",
  "TOKEN_INT16", "TOKEN_INT64", "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL",
  "TOKEN_UINT8", "TOKEN_UINT16", "TOKEN_UINT", "TOKEN_UINT64",
  "TOKEN_ENUM", "TOKEN_STRUCT", "TOKEN_TRUE", "TOKEN_FALSE", "TOKEN_CASE",
  "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE", "TOKEN_SWITCH", "TOKEN_WHILE",
  "TOKEN_DO", "TOKEN_LAUNCH", "TOKEN_FOREACH", "TOKEN_FOREACH_TILED",
  "TOKEN_FOREACH_UNIQUE", "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT",
  "TOKEN_FOR", "TOKEN_GOTO", "TOKEN_CONTINUE", "TOKEN_BREAK",
  "TOKEN_RETURN", "TOKEN_CIF", "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE",
  "TOKEN_SYNC", "TOKEN_PRINT", "TOKEN_ASSERT", "'('", "')'", "'['", "']'",
  "','", "'<'", "'>'", "'.'", "'&'", "'*'", "'+'", "'-'", "'~'", "'!'",
  "'/'", "'%'", "'^'", "'|'", "'?'", "':'", "'='", "';'", "'{'", "'}'",
  "$accept", "string_constant", "primary_expression", "launch_expression",
  "postfix_expression", "funcall_expression", "argument_expression_list",
  "unary_expression", "cast_expression", "multiplicative_expression",
  "additive_expression", "shift_expression", "relational_expression",
  "equality_expression", "and_expression", "exclusive_or_expression",
  "inclusive_or_expression", "logical_and_expression",
  "logical_or_expression", "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "init_declarator_list", "init_declarator",
  "storage_class_specifier", "type_specifier", "type_specifier_list",
  "atomic_var_type_specifier", "short_vec_specifier",
  "struct_or_union_name", "struct_or_union_and_name",
  "struct_or_union_specifier", "struct_or_union",
  "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "statement", "labeled_statement", "start_scope", "end_scope",
  "compound_statement", "statement_list", "expression_statement",
  "selection_statement", "for_test", "for_init_statement", "for_scope",
  "cfor_scope", "foreach_scope", "foreach_tiled_scope",
  "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    40,    41,    91,    93,    44,    60,
      62,    46,    38,    42,    43,    45,   126,    33,    47,    37,
      94,   124,    63,    58,    61,    59,   123,   125
};
# endif

#define YYPACT_NINF (-327)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-342)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     891,   -77,  -327,    37,   -68,  -327,  -327,  -327,  -327,   -20,
    -327,  -327,  -327,    12,  -327,  -327,  -327,  -327,  -327,  -327,
    -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,
      14,  -327,  -327,  -327,  3343,  3343,    56,  3343,  3280,  -327,
      20,  -327,     5,  -327,  3343,   852,  -327,  -327,  -327,    32,
     596,   159,   252,  -327,   190,    47,   118,  -327,  -327,  -327,
    -327,    62,  -327,   219,  -327,   -70,  -327,   -17,   160,    16,
      16,  -327,   252,  -327,  2911,  -327,  -327,  2940,  -327,  -327,
    -327,  -327,  3343,  -327,   -57,  -327,  -327,    -8,  -327,  -327,
    -327,  -327,   103,   130,   -42,  -327,   190,  -327,   198,  -327,
     219,  -327,    62,  -327,  1029,   193,  3145,  1619,   160,   160,
     232,  -327,  3382,   203,  -327,  2979,  -327,    62,  3382,  -327,
    3008,   248,    56,   596,   285,  -327,   159,  -327,  2582,     1,
    -327,   -33,  -327,  -327,  -327,  -327,   269,  -327,  -327,  -327,
    -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  2640,
    2640,  2698,  -327,   283,   359,  -327,  -327,   989,  1349,  2640,
    2640,  2582,  2582,  2582,  2582,  1029,  -327,  -327,   217,  -327,
     194,  -327,   124,   109,   270,    15,   278,   300,   301,   293,
     397,   -12,  -327,  2869,  -327,  -327,  -327,   308,   761,  -327,
      57,  -327,   108,   335,   339,  -327,   354,  -327,  -327,  -327,
     356,  -327,  -327,   252,  -327,  -327,   -56,  -327,  -327,  -327,
    -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,     3,  -327,
    1497,  -327,  -327,  1349,  -327,  -327,  -327,  2408,  1683,   227,
     367,   283,   359,  -327,    77,   105,   369,  -327,  -327,  -327,
    -327,  -327,  -327,  -327,   -22,   447,  -327,  -327,  1433,  1561,
     463,  2408,  2408,  2408,  2408,  2408,  2408,  2408,  2408,  2408,
    2408,  2408,  2582,  2582,  2582,  2582,  2582,  2582,  2582,  2582,
    2582,  2582,  2582,  2582,  2582,  2582,  2582,  2582,  2582,  2582,
    2408,   596,   596,   182,   596,  -327,  -327,   357,   365,  2408,
     364,  2582,   368,   388,   389,   391,   761,  -327,  -327,  -327,
    -327,  -327,   479,   374,   376,  1198,   399,   761,  -327,   400,
     381,   405,   414,  -327,   -49,  -327,  -327,  -327,  -327,  -327,
     507,  -327,  -327,   415,   417,   420,   422,   425,   429,  -327,
     411,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  2769,
    2466,   412,    39,    39,  -327,   220,  -327,  3343,  -327,  -327,
     428,    62,  -327,  -327,   430,   228,   267,  1768,  -327,  -327,
    2408,  2845,   268,   268,  -327,  2582,   965,  -327,  -327,   437,
    -327,    79,  -327,   433,   260,  -327,  -327,  -327,  -327,  -327,
    -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,  -327,
     124,   124,   109,   109,   270,   270,   270,   270,    15,    15,
     278,   300,   301,   293,   397,    19,  -327,  -327,  1029,  2408,
    -327,  -327,    -9,   761,   421,   761,  2408,  2408,  2408,   459,
    -327,   441,  -327,  -327,  -327,    -6,  2408,   461,  2408,  -327,
     534,   534,  -327,  -327,  -327,  -327,  1114,  1114,   571,   571,
     580,   594,   761,   505,  -327,   509,   510,  -327,   511,  1029,
     220,   220,  3221,  2524,  -327,  -327,  -327,  -327,  3082,  2408,
    1832,  -327,   117,  -327,  -327,  -327,  -327,  -327,  -327,  2408,
    -327,  -327,  2582,   155,   272,  -327,   634,   761,  -327,   167,
     189,   208,   513,  -327,  -327,   229,   521,   238,  -327,    10,
       9,  -327,  -327,  1262,  1262,  -327,   502,  -327,   239,   245,
    -327,   522,  -327,   582,  -327,  -327,  -327,  -327,  -327,  -327,
     540,  -327,   523,  2408,  1683,   360,   280,   536,   249,  -327,
    -327,  -327,  -327,  1029,  -327,  -327,  -327,   761,   761,   761,
    2408,   761,  2408,   761,  -327,   526,  2408,  2408,  -327,    53,
    1896,  1960,  1704,  -327,   571,  -327,  -327,  2408,  -327,  -327,
     541,   383,  2024,  1683,  2408,  -327,   537,   591,  -327,  -327,
     254,   598,   256,  -327,  -327,   261,   281,  -327,   761,   290,
     761,   294,  -327,  -327,  -327,  -327,   562,  2408,   761,  -327,
     761,   761,   296,  1241,  2088,  -327,   303,   394,   557,  -327,
     761,   568,   761,   600,   614,   615,  -327,   761,  -327,   761,
    2408,  -327,  -327,  -327,  -327,  -327,  2408,   435,   606,   321,
    -327,  2152,  1683,  -327,  -327,  -327,  -327,  -327,  -327,  -327,
    -327,  -327,   761,   635,  2216,  -327,   631,  -327,   329,   525,
    -327,  1683,  -327,   331,  -327,  -327,  2280,   652,  -327,  -327,
     337,  2344,  -327,  -327,   341,  -327
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   147,   143,   199,   145,   200,   201,   197,     0,
     195,   196,   142,     0,   198,   158,   202,   203,   160,   161,
     154,   156,   162,   194,   152,   153,   155,   157,   159,   163,
       0,   173,   340,   339,   131,   129,     0,   127,   133,   146,
     168,   148,     0,   149,   136,     0,   333,   336,   335,   144,
       0,     0,     0,   184,     0,   189,   143,   199,   132,   130,
     213,     0,   225,   221,   120,     0,   138,   140,   208,     0,
       0,   128,     0,   135,     0,   165,   166,     0,   167,   137,
       1,   334,     0,   150,     0,   123,   124,     0,   209,   210,
     211,   212,     0,   192,     0,   190,     0,   144,     0,   204,
     222,   223,     0,   121,     0,     0,     0,     0,   206,   207,
       0,   172,   178,   146,   179,     0,   174,     0,     0,   171,
       0,     0,     0,     0,     0,   126,     0,   122,     0,     0,
     185,     0,   214,   205,   224,   139,   140,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,     4,    17,     0,
       0,     0,    93,     0,     0,    15,    16,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,    39,    44,    50,
      61,    63,    67,    70,    73,    78,    81,    83,    85,    87,
      89,    91,   100,     0,   104,   250,   141,   271,     0,   342,
       0,   219,   233,     0,   226,   227,     0,   216,    61,   118,
       0,   134,   177,     0,   169,   175,     0,   181,   183,   180,
     170,   337,   151,   338,   125,   193,   187,   191,     0,   186,
       0,    51,    52,     0,    59,    94,    95,     0,     0,     0,
       0,   195,   196,   116,     0,   234,     0,    53,    54,    55,
      56,    57,    58,   253,     0,     0,    42,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   101,     0,    96,   273,     0,     4,     0,
     198,     0,     0,     0,     0,     0,     0,   290,   291,   303,
     293,   288,     0,     0,     0,     0,     0,     0,   289,     0,
       0,     0,     0,   277,     0,   261,   119,   275,   255,   256,
       0,   257,   258,     0,     0,     0,     0,     0,     0,   259,
       0,   260,   264,   265,   266,   262,   263,   220,   229,     0,
       0,   230,   236,   239,   232,   237,   218,     0,   217,   215,
       0,     0,   176,   188,     0,     0,     0,     0,    19,    18,
       0,     0,   236,   239,   235,     0,     0,   251,    41,     0,
      45,     0,    48,     0,     0,    40,   106,   107,   108,   109,
     110,   111,   112,   113,   115,   114,   105,    64,    65,    66,
      68,    69,    71,    72,    76,    77,    74,    75,    79,    80,
      82,    84,    86,    88,    90,     0,    97,    98,     0,     0,
      99,   267,     0,     0,     0,     0,     0,     0,     0,     0,
     321,     0,   323,   324,   325,     0,     0,     0,     0,   327,
       0,     0,   278,   272,   276,   274,     0,     0,     0,     0,
       0,     0,     0,     0,   246,     0,     0,   242,     0,     0,
     238,   240,     0,     0,   228,   164,   182,    60,     0,     0,
       0,    21,     0,   117,    62,   252,   254,    47,    46,     0,
      38,    37,     0,     0,     0,   328,     0,     0,   270,     0,
       0,     0,     0,   322,   326,     0,     0,     0,     2,     0,
       0,   287,   286,     0,     0,   292,     0,   301,     0,     0,
     294,     0,   304,     0,   268,   247,   241,   243,   231,   248,
       0,   244,     0,     0,     0,     0,     0,     0,     0,    20,
      49,    92,   102,     0,   103,   329,   269,     0,     0,     0,
       0,     0,     0,     0,     3,     0,     0,     0,   284,     0,
       0,     0,     0,   313,     0,   315,   317,     0,   249,   245,
       0,     0,     0,     0,     0,    33,     0,   279,   283,   305,
       0,   281,     0,   306,   330,     0,     0,   285,     0,     0,
       0,     0,   295,   296,   297,   298,     0,     0,     0,   302,
       0,     0,     0,     0,     0,    23,     0,     0,     0,    32,
       0,     0,     0,     0,     0,     0,   309,     0,   311,     0,
       0,   300,   314,   316,   318,   319,     0,     0,     0,     0,
      22,     0,     0,   280,   307,   282,   308,   331,   332,   310,
     312,   299,     0,     0,     0,    35,     0,    25,     0,     0,
     320,     0,    27,     0,    34,    24,     0,     0,    26,    29,
       0,     0,    28,    31,     0,    30
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -327,   312,  -327,  -327,  -156,  -327,  -326,   -72,  -150,   186,
     200,   -24,   196,   469,   476,   468,   475,   478,  -327,  -102,
    -327,  -327,  -327,  -104,  -117,  -124,    40,    22,   572,   628,
    -327,  -327,     2,  -327,   670,  -327,   202,  -327,    21,  -327,
    -327,  -327,  -327,  -327,   696,   -71,   -94,  -327,   423,   745,
    -327,   682,   -96,   -47,  -327,   -21,   -65,   -60,   -55,  -175,
    -100,  -327,   436,   563,  -142,  -280,  -101,   372,  -137,  -327,
    -327,  -327,   683,   377,    42,  -327,   295,   350,  -327,  -327,
    -327,  -327,  -327,  -327,  -327,  -327,   247,   353,  -327,  -327,
    -327,  -327,  -327,  -327,  -327,   491,  -327,  -327,  -327,  -327,
    -327,  -327,  -327,   749,  -327,  -327
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   489,   166,   167,   168,   169,   371,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   283,   184,   233,   314,   200,   315,   316,    34,    86,
      87,    35,   122,    65,    66,    37,    38,    84,    39,   114,
      78,    40,    41,    42,   115,   116,   117,   206,   207,    93,
      43,    94,    95,    44,   100,    98,    92,    68,    69,    70,
     445,   194,   195,   236,   446,   345,   243,   244,   317,   318,
     188,   435,   319,   320,   321,   322,   540,   493,   323,   324,
     325,   326,   496,   327,   501,   577,   497,   498,   328,   503,
     329,   578,   580,   581,   622,   330,   331,   332,   333,   334,
     335,   336,    45,    46,    47,   105
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     185,   229,    36,   186,   215,   199,   193,   110,   101,   108,
     109,   239,   240,   241,   242,    67,    99,   343,   202,    53,
     279,    53,    33,    75,   209,    76,   199,   118,   534,   534,
     118,   462,    53,   217,    60,   198,    58,    59,   102,    71,
      73,   234,   269,   270,   205,   134,    79,    36,    48,   205,
     344,   123,   351,   133,    49,   103,   198,    60,    50,   360,
     363,   185,   450,   451,   235,   118,   129,    33,   118,   352,
     124,   118,   356,   118,    60,   218,   432,   221,   222,   224,
      60,   136,   450,   451,    51,   130,   366,   237,   238,   198,
     198,   198,   198,   364,   219,   113,   208,   125,   113,   360,
     126,   136,   360,   234,   121,   367,   234,   104,   192,  -341,
     280,   118,   387,   388,   389,   535,   475,   537,   536,   484,
      61,    52,   217,   355,   271,   272,    60,   360,   216,   235,
     353,    77,   374,   113,   518,    97,   113,   342,   350,   113,
      54,   113,   472,   339,   372,   340,    74,   376,   377,   378,
     379,   380,   381,   382,   383,   384,   385,   386,    82,   419,
      61,   360,   337,   405,   343,   338,    61,   414,    62,    63,
     427,   341,   412,    96,    62,    63,   118,    85,   567,   113,
     362,    64,   359,   434,   468,   360,   363,   469,   425,   199,
     198,   198,   198,   198,   198,   198,   198,   198,   198,   198,
     198,   198,   198,   198,   198,   198,   198,   198,    53,   361,
     565,   340,   339,   127,   340,   464,   448,    62,    63,   198,
      62,    63,   519,   265,   266,   469,   586,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   262,   199,   245,
     246,   247,   263,   264,   113,   394,   395,   396,   397,   245,
     246,   247,    83,   372,   128,    88,   463,    89,   609,    90,
     522,    91,   185,   523,   106,   466,   107,    57,   198,     6,
       7,     8,   527,    10,    11,   360,   112,    14,   478,   112,
      16,    17,   108,   109,   342,   628,   408,    23,   409,   245,
     246,   247,   474,   198,   528,   267,   268,   360,   633,   479,
     480,   481,   515,   132,   185,   504,   362,   273,   274,   485,
     640,   487,   203,   529,   112,   644,   360,   112,   261,   187,
     112,   248,   112,   249,   452,   212,   453,   225,   250,   512,
     208,   357,    63,   249,   531,   458,   459,   360,   250,   434,
     526,   192,   201,   533,   543,   185,   360,   544,   508,   192,
     545,   199,   510,   544,   556,   516,   372,   469,   551,   591,
     112,   593,   360,   192,   360,   520,   594,   471,   360,   469,
     521,   460,   361,   249,   340,   211,   539,   539,   250,   524,
     360,   198,   245,   246,   247,   285,   595,   553,   554,   360,
     557,   558,   559,   104,   561,   597,   563,   587,   360,   599,
     198,   605,   360,   226,   360,   245,   246,   247,   610,   550,
     213,   469,   275,   560,   277,   562,   245,   246,   247,   185,
     566,   276,   466,   569,   571,   112,   626,   607,   278,   469,
     582,   596,   372,   598,   635,   286,   638,   469,   576,   469,
     346,   602,   642,   603,   604,   469,   645,   347,   372,   469,
     588,   390,   391,   613,   192,   615,   629,   245,   246,   247,
     619,   348,   620,   349,   552,   368,   249,   392,   393,   398,
     399,   250,   358,   601,   365,   637,   491,   491,   492,   492,
     372,   375,   411,   406,   407,   630,   410,   584,  -321,   249,
     413,   415,   416,   417,   250,   418,   621,   420,   611,   422,
     249,   423,   623,   426,   428,   250,   429,   372,   287,   430,
     137,   138,   139,   140,   141,   142,   143,   144,   431,   436,
     372,   437,   145,   146,   438,   288,   439,     2,   148,   440,
     149,   150,   372,   441,   442,   457,   449,   372,   455,   624,
     470,   249,   467,   482,   477,   486,   250,   245,   246,   247,
     151,   152,   289,   488,    56,    57,     5,     6,     7,     8,
       9,   231,   232,    12,    13,   290,   483,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,   155,   156,   291,   292,   293,   495,
     294,   295,   296,   157,   297,   298,   299,   300,   500,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   158,   502,   338,   505,   506,     2,   530,   507,   159,
     160,   161,   162,   163,   164,   532,   542,   546,   547,   636,
     549,   249,   313,   187,   433,   287,   250,   137,   138,   139,
     140,   141,   142,   143,   144,   548,   555,   589,   583,   145,
     146,   564,   288,   600,     2,   148,    15,   149,   150,    18,
      19,    20,    21,    22,   612,    24,    25,    26,    27,    28,
      29,    30,    31,   590,   245,   246,   247,   151,   152,   289,
     592,    56,    57,     5,     6,     7,     8,     9,   231,   232,
      12,    13,   290,   614,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   155,   156,   291,   292,   293,   625,   294,   295,   296,
     157,   297,   298,   299,   300,   616,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   158,   617,
     618,   634,   631,   490,   400,   402,   159,   160,   161,   162,
     163,   164,   401,   403,   214,   284,   641,   404,   249,   313,
     187,   525,   287,   250,   137,   138,   139,   140,   141,   142,
     143,   144,   135,   120,   456,    55,   145,   146,   131,   288,
     473,     2,   148,   454,   149,   150,   354,   494,   189,   541,
     476,   579,   499,   421,    81,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   151,   152,   289,     0,    56,    57,
       5,     6,     7,     8,     9,   231,   232,    12,    13,   290,
       0,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,   155,   156,
     291,   292,   293,     0,   294,   295,   296,   157,   297,   298,
     299,   300,    80,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   158,     0,     0,     0,     0,
       0,     0,     2,   159,   160,   161,   162,   163,   164,     0,
       0,     0,     0,     0,     0,     0,   313,   187,     0,     0,
       0,     0,     1,     0,     0,     0,     0,     0,     0,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,     2,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
       0,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,   137,   138,
     139,   140,   141,   142,   143,   144,     0,    32,     0,     0,
     145,   146,     0,   147,     0,     0,   148,     0,   149,   150,
       0,     0,   137,   138,   139,   140,   141,   142,   143,   144,
       0,     0,     0,     0,   145,   146,     0,   147,   151,   152,
     148,     0,     0,     0,     0,     0,    32,     0,     0,   153,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   137,   138,   139,   140,   141,   142,   143,   144,
       0,     0,   155,   156,   145,   146,     0,   147,     0,     0,
     148,   157,   149,   150,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   155,   156,     0,   158,
       0,     0,   151,   152,     0,   157,     0,   159,   160,   161,
     162,   163,   164,   153,   154,     0,     0,     0,     0,     0,
       0,   165,   465,   220,     0,   227,     0,     0,   228,     0,
       0,     0,     0,     0,     0,     0,   155,   156,     0,     0,
       0,     0,     0,     0,     0,   157,     0,   137,   138,   139,
     140,   141,   142,   143,   144,     0,     0,     0,     0,   145,
     146,     0,   147,   158,     2,   148,     0,   149,   150,     0,
       0,   159,   160,   161,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,   165,     0,   151,   152,     0,
       0,    56,    57,     5,     6,     7,     8,     9,   231,   232,
      12,    13,    14,     0,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,   155,   156,     0,     0,     0,     0,     0,     0,     0,
     157,   137,   138,   139,   140,   141,   142,   143,   144,     0,
       0,     0,     0,   145,   146,     0,   147,     0,   158,   148,
       0,   149,   150,     0,     0,     0,   159,   160,   161,   162,
     163,   164,     0,     0,     0,     0,     0,     0,     0,   313,
       0,   151,   152,     0,   137,   138,   139,   140,   141,   142,
     143,   144,   153,   154,     0,     0,   145,   146,     0,   147,
       0,     0,   148,     0,     0,   137,   138,   139,   140,   141,
     142,   143,   144,     0,     0,   155,   156,   145,   146,     0,
     147,     0,     0,   148,   157,   149,   150,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,     0,     0,   151,   152,     0,     0,     0,
     159,   160,   161,   162,   163,   164,   153,   154,   155,   156,
       0,     0,     0,   424,     0,     0,     0,   157,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
     156,     0,     0,     0,     0,   220,     0,   606,   157,     0,
     230,     0,   137,   138,   139,   140,   141,   142,   143,   144,
       0,     0,     0,     0,   145,   146,   158,   147,     0,     2,
     148,     0,   149,   150,   159,   160,   161,   162,   163,   164,
       0,     0,     0,     0,     0,     0,     0,   538,     0,     0,
       0,     0,   151,   152,     0,     0,     0,    57,     0,     6,
       7,     8,     0,   231,   232,     0,     0,    14,     0,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   155,   156,     0,     0,
       0,     0,     0,     0,   369,   157,   137,   138,   139,   140,
     141,   142,   143,   144,     0,     0,     0,     0,   145,   146,
       0,   147,     0,   158,   148,     0,   149,   150,     0,     0,
       0,   159,   160,   161,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   151,   152,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   153,   154,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   230,     0,
     137,   138,   139,   140,   141,   142,   143,   144,     0,     0,
     155,   156,   145,   146,     0,   147,     0,     0,   148,   157,
     149,   150,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   158,   370,     0,
     151,   152,     0,     0,     0,   159,   160,   161,   162,   163,
     164,   153,   154,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   373,     0,   137,   138,   139,   140,   141,   142,
     143,   144,     0,     0,   155,   156,   145,   146,     0,   147,
       0,     0,   148,   157,   149,   150,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   158,     0,     0,   151,   152,     0,     0,     0,   159,
     160,   161,   162,   163,   164,   153,   154,     0,     0,     0,
     196,     0,   137,   138,   139,   140,   141,   142,   143,   144,
       0,     0,     0,     0,   145,   146,     0,   147,   155,   156,
     148,     0,   149,   150,     0,     0,     0,   157,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   151,     0,     0,   158,     0,     0,     0,     0,
       0,     0,     0,   159,   160,   161,   162,   163,   164,     0,
       0,     0,     0,     0,     0,     0,   137,   138,   139,   140,
     141,   142,   143,   144,     0,     0,   155,   156,   145,   146,
       0,   147,     0,     0,   148,   157,     0,   137,   138,   139,
     140,   141,   142,   143,   144,   572,   573,   574,   575,   145,
     146,     0,   147,   158,     0,   148,   197,   149,   150,     0,
       0,   159,   160,   161,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   151,   152,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   153,   154,
     155,   156,     0,     0,     0,     0,     0,     0,     0,   157,
       0,   137,   138,   139,   140,   141,   142,   143,   144,     0,
       0,   155,   156,   145,   146,     0,   147,   220,     0,   148,
     157,   149,   150,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,     0,
       0,   151,   152,     0,     0,     0,   159,   160,   161,   162,
     163,   164,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   137,   138,   139,   140,   141,
     142,   143,   144,     0,     0,   155,   156,   145,   146,     0,
     147,     0,     0,   148,   157,   149,   150,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,   461,     0,   151,   152,     0,     0,     0,
     159,   160,   161,   162,   163,   164,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   137,
     138,   139,   140,   141,   142,   143,   144,     0,     0,   155,
     156,   145,   146,     0,   147,     0,     0,   148,   157,   149,
     150,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   158,   517,     0,   151,
     152,     0,     0,     0,   159,   160,   161,   162,   163,   164,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   137,   138,   139,   140,   141,   142,   143,
     144,     0,     0,   155,   156,   145,   146,     0,   147,     0,
       0,   148,   157,   149,   150,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     158,   568,     0,   151,   152,     0,     0,     0,   159,   160,
     161,   162,   163,   164,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   137,   138,   139,
     140,   141,   142,   143,   144,     0,     0,   155,   156,   145,
     146,     0,   147,     0,     0,   148,   157,   149,   150,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   158,   570,     0,   151,   152,     0,
       0,     0,   159,   160,   161,   162,   163,   164,   153,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   137,   138,   139,   140,   141,   142,   143,   144,     0,
       0,   155,   156,   145,   146,     0,   147,     0,     0,   148,
     157,   149,   150,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,   585,
       0,   151,   152,     0,     0,     0,   159,   160,   161,   162,
     163,   164,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   137,   138,   139,   140,   141,
     142,   143,   144,     0,     0,   155,   156,   145,   146,     0,
     147,     0,     0,   148,   157,   149,   150,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   158,   608,     0,   151,   152,     0,     0,     0,
     159,   160,   161,   162,   163,   164,   153,   154,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   137,
     138,   139,   140,   141,   142,   143,   144,     0,     0,   155,
     156,   145,   146,     0,   147,     0,     0,   148,   157,   149,
     150,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   158,   627,     0,   151,
     152,     0,     0,     0,   159,   160,   161,   162,   163,   164,
     153,   154,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   137,   138,   139,   140,   141,   142,   143,
     144,     0,     0,   155,   156,   145,   146,     0,   147,     0,
       0,   148,   157,   149,   150,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     158,   632,     0,   151,   152,     0,     0,     0,   159,   160,
     161,   162,   163,   164,   153,   154,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   137,   138,   139,
     140,   141,   142,   143,   144,     0,     0,   155,   156,   145,
     146,     0,   147,     0,     0,   148,   157,   149,   150,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   158,   639,     0,   151,   152,     0,
       0,     0,   159,   160,   161,   162,   163,   164,   153,   154,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   137,   138,   139,   140,   141,   142,   143,   144,     0,
       0,   155,   156,   145,   146,     0,   147,     0,     0,   148,
     157,   149,   150,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   158,   643,
       0,   151,   152,     0,     0,     0,   159,   160,   161,   162,
     163,   164,   153,   154,     0,     0,     0,     0,     0,   137,
     138,   139,   140,   141,   142,   143,   144,     0,     0,     0,
       0,   145,   146,     0,   147,   155,   156,   148,     0,   149,
     150,     0,     0,     0,   157,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   151,
       0,     0,   158,     0,     0,     0,     0,     0,     0,     0,
     159,   160,   161,   162,   163,   164,     0,   137,   138,   139,
     140,   141,   142,   143,   144,     0,     0,     0,     0,   145,
     146,     0,   147,   155,   156,   148,     0,   149,   150,     0,
       0,     0,   157,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   151,     0,     0,
     158,     0,     0,   447,     0,     0,     0,     0,   159,   160,
     161,   162,   163,   164,     0,   137,   138,   139,   140,   141,
     142,   143,   144,     0,     0,     0,     0,   145,   146,     0,
     147,   155,   156,   148,     0,   149,   150,     0,     0,     0,
     157,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   151,     0,     0,   158,     0,
       0,   511,     0,     0,     0,     0,   159,   160,   161,   162,
     163,   164,     0,   137,   138,   139,   140,   141,   142,   143,
     144,     0,     0,     0,     0,   145,   146,     0,   147,   155,
     156,   148,     0,   149,   150,     0,     0,     0,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   151,     0,     0,   158,     0,     0,     0,
       0,     0,     0,     0,   159,   160,   161,   162,   163,   164,
       0,   137,   138,   139,   140,   141,   142,   143,   144,     0,
       0,     0,     0,   145,   146,     0,   147,   155,   156,   148,
       0,   149,   150,     0,     0,     0,   157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   151,     0,     0,   220,     0,     0,     0,     0,     0,
       0,     0,   159,   160,   161,   162,   163,   164,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     443,     0,     0,     0,     0,   155,   156,     0,     0,     0,
       0,     0,     0,     0,   157,     0,     0,    60,     0,     2,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   223,     0,     0,     0,     0,     0,     0,     0,
     159,   160,   161,   162,   163,   164,    56,    57,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,     0,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   443,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     0,
       0,     0,     0,   339,   444,   340,     0,     0,     0,     0,
       0,    62,    63,     0,     0,     0,     0,     0,     0,     2,
       0,     0,    56,    57,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,     0,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,     0,   281,   282,     0,    13,     0,     0,    15,
       0,     2,    18,    19,    20,    21,    22,     0,    24,    25,
      26,    27,    28,    29,    30,    31,     0,     0,     0,   361,
     444,   340,     0,     0,     0,     0,     0,    62,    63,    57,
       2,     6,     7,     8,     0,    10,    11,     0,     0,    14,
       0,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    57,     0,
       6,     7,     8,     0,    10,    11,     0,     0,    14,     2,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    57,     2,     6,
       7,     8,     0,    10,    11,     0,     0,    14,   111,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    57,     0,     6,     7,
       8,     0,    10,    11,     0,     0,    14,   119,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,   137,   138,   139,   140,   141,
     142,   143,   144,     0,     0,     0,     0,   145,   146,     0,
     147,     0,     0,   148,     0,     0,   204,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   210,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   190,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
     156,     0,     0,     0,     0,     2,     0,     0,   157,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   220,     0,   513,     0,
       0,   514,    56,    57,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,     0,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,   443,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     191,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    56,    57,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
       0,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,     0,     0,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   509,    56,    57,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,     0,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,     0,     0,     0,
       0,     0,     0,     2,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
      56,    57,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,     2,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      57,     0,     6,     7,     8,     0,    10,    11,     0,     0,
      14,     0,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31
};

static const yytype_int16 yycheck[] =
{
     104,   157,     0,   104,   128,   107,   106,    72,    63,    69,
      70,   161,   162,   163,   164,    36,    63,   192,   112,    18,
      32,    18,     0,    18,   118,    20,   128,    74,    19,    19,
      77,   357,    18,   129,    18,   107,    34,    35,   108,    37,
      38,   158,    27,    28,   115,   100,    44,    45,   125,   120,
     192,   108,   108,   100,    17,   125,   128,    18,   126,   108,
     235,   165,   342,   343,   158,   112,   108,    45,   115,   125,
     127,   118,   228,   120,    18,   108,   125,   149,   150,   151,
      18,   102,   362,   363,   104,   127,   108,   159,   160,   161,
     162,   163,   164,   235,   127,    74,   117,   105,    77,   108,
     108,   122,   108,   220,    82,   127,   223,   124,   106,   126,
     122,   158,   262,   263,   264,   105,   125,   108,   108,   125,
     104,   109,   218,   227,   109,   110,    18,   108,   127,   223,
     127,   126,   249,   112,   460,    17,   115,   192,   203,   118,
     126,   120,   123,   104,   248,   106,   126,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   126,   296,
     104,   108,   105,   280,   339,   108,   104,   291,   112,   113,
     307,   192,   289,   126,   112,   113,   223,    18,   125,   158,
     235,   125,   105,   320,   105,   108,   361,   108,   305,   291,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,    18,   104,
     536,   106,   104,   110,   106,   365,   340,   112,   113,   291,
     112,   113,   105,   114,   115,   108,   552,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,   113,   340,    22,
      23,    24,   118,   119,   223,   269,   270,   271,   272,    22,
      23,    24,    50,   357,   124,     3,   360,     5,   584,     7,
     105,     9,   366,   108,   104,   366,   106,    48,   340,    50,
      51,    52,   105,    54,    55,   108,    74,    58,   415,    77,
      61,    62,   342,   343,   339,   611,   104,    68,   106,    22,
      23,    24,   409,   365,   105,    25,    26,   108,   624,   416,
     417,   418,   458,   105,   408,   442,   361,    29,    30,   426,
     636,   428,   109,   105,   112,   641,   108,   115,   124,   126,
     118,   104,   120,   106,   104,   123,   106,    44,   111,   453,
     351,   104,   113,   106,   105,   107,   108,   108,   111,   476,
     477,   339,   110,   105,   105,   449,   108,   108,   449,   347,
     105,   453,   452,   108,   105,   459,   460,   108,   514,   105,
     158,   105,   108,   361,   108,   469,   105,   107,   108,   108,
     472,   104,   104,   106,   106,   127,   493,   494,   111,   107,
     108,   453,    22,    23,    24,   183,   105,   107,   108,   108,
     527,   528,   529,   124,   531,   105,   533,   553,   108,   105,
     472,   105,   108,    44,   108,    22,    23,    24,   105,   513,
     125,   108,   112,   530,   121,   532,    22,    23,    24,   523,
     537,   120,   523,   540,   541,   223,   105,   583,    31,   108,
     547,   568,   536,   570,   105,   127,   105,   108,   542,   108,
     105,   578,   105,   580,   581,   108,   105,   108,   552,   108,
     554,   265,   266,   590,   452,   592,   612,    22,    23,    24,
     597,   107,   599,   107,   104,    18,   106,   267,   268,   273,
     274,   111,   105,   577,   105,   631,   436,   437,   436,   437,
     584,    18,   125,   281,   282,   622,   284,   104,   123,   106,
     126,   123,   104,   104,   111,   104,   600,    18,   104,   125,
     106,   125,   606,   104,   104,   111,   125,   611,     1,   104,
       3,     4,     5,     6,     7,     8,     9,    10,   104,   104,
     624,   104,    15,    16,   104,    18,   104,    20,    21,   104,
      23,    24,   636,   104,   123,   105,   124,   641,   110,   104,
     107,   106,   105,    84,   123,    84,   111,    22,    23,    24,
      43,    44,    45,    19,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,   125,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    18,
      83,    84,    85,    86,    87,    88,    89,    90,    18,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,    18,   108,   105,   105,    20,   104,   107,   112,
     113,   114,   115,   116,   117,   104,   124,   105,    46,   104,
     107,   106,   125,   126,   127,     1,   111,     3,     4,     5,
       6,     7,     8,     9,    10,   105,   110,   110,   107,    15,
      16,   125,    18,    91,    20,    21,    60,    23,    24,    63,
      64,    65,    66,    67,   107,    69,    70,    71,    72,    73,
      74,    75,    76,    82,    22,    23,    24,    43,    44,    45,
      82,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,   125,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,   110,    83,    84,    85,
      86,    87,    88,    89,    90,   125,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   125,
     125,   110,   107,   431,   275,   277,   112,   113,   114,   115,
     116,   117,   276,   278,   126,   183,   104,   279,   106,   125,
     126,   127,     1,   111,     3,     4,     5,     6,     7,     8,
       9,    10,   102,    77,   351,    30,    15,    16,    96,    18,
     408,    20,    21,   347,    23,    24,   223,   437,   105,   494,
     413,   544,   439,   302,    45,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    -1,    83,    84,    85,    86,    87,    88,
      89,    90,     0,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    20,   112,   113,   114,   115,   116,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   125,   126,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    20,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,   125,    -1,    -1,
      15,    16,    -1,    18,    -1,    -1,    21,    -1,    23,    24,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    18,    43,    44,
      21,    -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    77,    78,    15,    16,    -1,    18,    -1,    -1,
      21,    86,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,   104,
      -1,    -1,    43,    44,    -1,    86,    -1,   112,   113,   114,
     115,   116,   117,    54,    55,    -1,    -1,    -1,    -1,    -1,
      -1,   126,   127,   104,    -1,   106,    -1,    -1,   109,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    18,   104,    20,    21,    -1,    23,    24,    -1,
      -1,   112,   113,   114,   115,   116,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   126,    -1,    43,    44,    -1,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      86,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,    -1,   104,    21,
      -1,    23,    24,    -1,    -1,    -1,   112,   113,   114,   115,
     116,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,
      -1,    43,    44,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    54,    55,    -1,    -1,    15,    16,    -1,    18,
      -1,    -1,    21,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    77,    78,    15,    16,    -1,
      18,    -1,    -1,    21,    86,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,    43,    44,    -1,    -1,    -1,
     112,   113,   114,   115,   116,   117,    54,    55,    77,    78,
      -1,    -1,    -1,   125,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    -1,    -1,   104,    -1,   106,    86,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,   104,    18,    -1,    20,
      21,    -1,    23,    24,   112,   113,   114,   115,   116,   117,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,    -1,    -1,
      -1,    -1,    43,    44,    -1,    -1,    -1,    48,    -1,    50,
      51,    52,    -1,    54,    55,    -1,    -1,    58,    -1,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    86,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      -1,    18,    -1,   104,    21,    -1,    23,    24,    -1,    -1,
      -1,   112,   113,   114,   115,   116,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      77,    78,    15,    16,    -1,    18,    -1,    -1,    21,    86,
      23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,    -1,
      43,    44,    -1,    -1,    -1,   112,   113,   114,   115,   116,
     117,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    77,    78,    15,    16,    -1,    18,
      -1,    -1,    21,    86,    23,    24,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,    43,    44,    -1,    -1,    -1,   112,
     113,   114,   115,   116,   117,    54,    55,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    -1,    18,    77,    78,
      21,    -1,    23,    24,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    43,    -1,    -1,   104,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,   113,   114,   115,   116,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    77,    78,    15,    16,
      -1,    18,    -1,    -1,    21,    86,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    -1,    18,   104,    -1,    21,   107,    23,    24,    -1,
      -1,   112,   113,   114,   115,   116,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    44,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    54,    55,
      77,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    86,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    77,    78,    15,    16,    -1,    18,   104,    -1,    21,
      86,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,    43,    44,    -1,    -1,    -1,   112,   113,   114,   115,
     116,   117,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    77,    78,    15,    16,    -1,
      18,    -1,    -1,    21,    86,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,   105,    -1,    43,    44,    -1,    -1,    -1,
     112,   113,   114,   115,   116,   117,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    77,
      78,    15,    16,    -1,    18,    -1,    -1,    21,    86,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,   105,    -1,    43,
      44,    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    77,    78,    15,    16,    -1,    18,    -1,
      -1,    21,    86,    23,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,   105,    -1,    43,    44,    -1,    -1,    -1,   112,   113,
     114,   115,   116,   117,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    77,    78,    15,
      16,    -1,    18,    -1,    -1,    21,    86,    23,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,   105,    -1,    43,    44,    -1,
      -1,    -1,   112,   113,   114,   115,   116,   117,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    77,    78,    15,    16,    -1,    18,    -1,    -1,    21,
      86,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,
      -1,    43,    44,    -1,    -1,    -1,   112,   113,   114,   115,
     116,   117,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    77,    78,    15,    16,    -1,
      18,    -1,    -1,    21,    86,    23,    24,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,   105,    -1,    43,    44,    -1,    -1,    -1,
     112,   113,   114,   115,   116,   117,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    77,
      78,    15,    16,    -1,    18,    -1,    -1,    21,    86,    23,
      24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,   105,    -1,    43,
      44,    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,
      54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    77,    78,    15,    16,    -1,    18,    -1,
      -1,    21,    86,    23,    24,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,   105,    -1,    43,    44,    -1,    -1,    -1,   112,   113,
     114,   115,   116,   117,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    77,    78,    15,
      16,    -1,    18,    -1,    -1,    21,    86,    23,    24,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,   105,    -1,    43,    44,    -1,
      -1,    -1,   112,   113,   114,   115,   116,   117,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    77,    78,    15,    16,    -1,    18,    -1,    -1,    21,
      86,    23,    24,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,
      -1,    43,    44,    -1,    -1,    -1,   112,   113,   114,   115,
     116,   117,    54,    55,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    -1,    18,    77,    78,    21,    -1,    23,
      24,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     112,   113,   114,   115,   116,   117,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    -1,    18,    77,    78,    21,    -1,    23,    24,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,
     104,    -1,    -1,   107,    -1,    -1,    -1,    -1,   112,   113,
     114,   115,   116,   117,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      18,    77,    78,    21,    -1,    23,    24,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    43,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,   112,   113,   114,   115,
     116,   117,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    16,    -1,    18,    77,
      78,    21,    -1,    23,    24,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    -1,    -1,   104,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   112,   113,   114,   115,   116,   117,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    -1,    18,    77,    78,    21,
      -1,    23,    24,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   112,   113,   114,   115,   116,   117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,    -1,    77,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    18,    -1,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     112,   113,   114,   115,   116,   117,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,   105,   106,    -1,    -1,    -1,    -1,
      -1,   112,   113,    -1,    -1,    -1,    -1,    -1,    -1,    20,
      -1,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    -1,    54,    55,    -1,    57,    -1,    -1,    60,
      -1,    20,    63,    64,    65,    66,    67,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    -1,    -1,    -1,   104,
     105,   106,    -1,    -1,    -1,    -1,    -1,   112,   113,    48,
      20,    50,    51,    52,    -1,    54,    55,    -1,    -1,    58,
      -1,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    48,    -1,
      50,    51,    52,    -1,    54,    55,    -1,    -1,    58,    20,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    20,    50,
      51,    52,    -1,    54,    55,    -1,    -1,    58,   127,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    48,    -1,    50,    51,
      52,    -1,    54,    55,    -1,    -1,    58,   127,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    -1,
      18,    -1,    -1,    21,    -1,    -1,   127,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   127,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      78,    -1,    -1,    -1,    -1,    20,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,   106,    -1,
      -1,   109,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     105,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    -1,    -1,
      20,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   105,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    20,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    20,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    -1,    54,    55,    -1,    -1,
      58,    -1,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    20,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,   125,   155,   156,   159,   160,   163,   164,   166,
     169,   170,   171,   178,   181,   230,   231,   232,   125,    17,
     126,   104,   109,    18,   126,   177,    47,    48,   160,   160,
      18,   104,   112,   113,   125,   161,   162,   183,   185,   186,
     187,   160,   109,   160,   126,    18,    20,   126,   168,   160,
       0,   231,   126,   164,   165,    18,   157,   158,     3,     5,
       7,     9,   184,   177,   179,   180,   126,    17,   183,   181,
     182,   186,   108,   125,   124,   233,   104,   106,   185,   185,
     184,   127,   164,   166,   167,   172,   173,   174,   181,   127,
     172,   155,   160,   108,   127,   105,   108,   110,   124,   108,
     127,   179,   105,   181,   186,   162,   183,     3,     4,     5,
       6,     7,     8,     9,    10,    15,    16,    18,    21,    23,
      24,    43,    44,    54,    55,    77,    78,    86,   104,   112,
     113,   114,   115,   116,   117,   126,   130,   131,   132,   133,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   150,   151,   194,   126,   198,   200,
       1,   105,   160,   188,   189,   190,     1,   107,   135,   147,
     153,   110,   174,   109,   127,   173,   175,   176,   183,   174,
     127,   127,   164,   125,   157,   153,   127,   180,   108,   127,
     104,   135,   135,   104,   135,    44,    44,   106,   109,   132,
       1,    54,    55,   151,   152,   174,   191,   135,   135,   136,
     136,   136,   136,   194,   195,    22,    23,    24,   104,   106,
     111,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,   124,   113,   118,   119,   114,   115,    25,    26,    27,
      28,   109,   110,    29,    30,   112,   120,   121,    31,    32,
     122,    54,    55,   149,   156,   164,   127,     1,    18,    45,
      58,    79,    80,    81,    83,    84,    85,    87,    88,    89,
      90,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   125,   152,   154,   155,   196,   197,   200,
     201,   202,   203,   206,   207,   208,   209,   211,   216,   218,
     223,   224,   225,   226,   227,   228,   229,   105,   108,   104,
     106,   183,   186,   187,   192,   193,   105,   108,   107,   107,
     184,   108,   125,   127,   191,   151,   132,   104,   105,   105,
     108,   104,   186,   187,   192,   105,   108,   127,    18,     1,
     105,   134,   151,     1,   152,    18,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   136,   136,   136,
     137,   137,   138,   138,   139,   139,   139,   139,   140,   140,
     141,   142,   143,   144,   145,   152,   164,   164,   104,   106,
     164,   125,   152,   126,   153,   123,   104,   104,   104,   196,
      18,   223,   125,   125,   125,   152,   104,   196,   104,   125,
     104,   104,   125,   127,   196,   199,   104,   104,   104,   104,
     104,   104,   123,     1,   105,   188,   192,   107,   153,   124,
     193,   193,   104,   106,   190,   110,   176,   105,   107,   108,
     104,   105,   134,   151,   136,   127,   194,   105,   105,   108,
     107,   107,   123,   195,   152,   125,   201,   123,   196,   152,
     152,   152,    84,   125,   125,   152,    84,   152,    19,   129,
     129,   154,   202,   205,   205,    18,   210,   214,   215,   215,
      18,   212,    18,   217,   196,   105,   105,   107,   194,   105,
     188,   107,   153,   106,   109,   132,   151,   105,   134,   105,
     151,   147,   105,   108,   107,   127,   196,   105,   105,   105,
     104,   105,   104,   105,    19,   105,   108,   108,   125,   152,
     204,   204,   124,   105,   108,   105,   105,    46,   105,   107,
     151,   132,   104,   107,   108,   110,   105,   196,   196,   196,
     152,   196,   152,   196,   125,   134,   152,   125,   105,   152,
     105,   152,    11,    12,    13,    14,   151,   213,   219,   214,
     220,   221,   152,   107,   104,   105,   134,   132,   151,   110,
      82,   105,    82,   105,   105,   105,   196,   105,   196,   105,
      91,   151,   196,   196,   196,   105,   106,   132,   105,   134,
     105,   104,   107,   196,   125,   196,   125,   125,   125,   196,
     196,   151,   222,   151,   104,   110,   105,   105,   134,   132,
     196,   107,   105,   134,   110,   105,   104,   132,   105,   105,
     134,   104,   105,   105,   134,   105
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   128,   129,   129,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   132,   132,   132,   132,
     132,   132,   132,   132,   133,   133,   133,   133,   134,   134,
     135,   135,   135,   135,   135,   135,   135,   135,   135,   135,
     135,   136,   136,   137,   137,   137,   137,   138,   138,   138,
     139,   139,   139,   140,   140,   140,   140,   140,   141,   141,
     141,   142,   142,   143,   143,   144,   144,   145,   145,   146,
     146,   147,   147,   148,   148,   148,   149,   149,   149,   149,
     150,   150,   150,   150,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   152,   152,   153,   154,
     155,   155,   156,   157,   158,   158,   159,   160,   160,   160,
     160,   160,   160,   160,   160,   160,   160,   160,   161,   161,
     162,   162,   163,   163,   163,   163,   164,   164,   164,   164,
     165,   165,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   167,   168,   168,   169,   170,   170,
     170,   170,   170,   171,   172,   172,   173,   174,   174,   174,
     174,   175,   175,   176,   177,   178,   178,   178,   178,   178,
     179,   179,   180,   180,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   182,   182,   183,   183,   183,   184,
     184,   184,   184,   185,   185,   185,   185,   185,   185,   185,
     185,   186,   186,   186,   186,   187,   188,   189,   189,   189,
     190,   190,   190,   190,   191,   191,   192,   192,   192,   192,
     192,   193,   193,   193,   193,   193,   193,   193,   193,   193,
     194,   194,   194,   195,   195,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   197,   197,
     197,   198,   199,   200,   200,   201,   201,   202,   202,   203,
     203,   203,   203,   203,   204,   204,   205,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   213,   213,   213,   214,
     214,   215,   215,   216,   217,   218,   218,   218,   218,   218,
     218,   218,   218,   219,   218,   220,   218,   221,   218,   222,
     218,   223,   224,   224,   224,   224,   224,   225,   226,   227,
     228,   228,   229,   230,   230,   230,   231,   231,   231,   231,
     231,   233,   232
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       5,     4,     8,     7,    10,     9,    11,    10,    12,    11,
      14,    13,     7,     6,    10,     9,     1,     4,     4,     1,
       3,     3,     2,     2,     1,     3,     4,     4,     1,     3,
       1,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       4,     1,     4,     1,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     5,     1,     2,     2,     1,     2,     2,     2,
       1,     2,     5,     5,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     1,     1,
       2,     3,     4,     1,     1,     3,     4,     1,     2,     1,
       2,     1,     2,     1,     4,     2,     1,     2,     1,     3,
       1,     3,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     1,     1,     2,     1,     4,
       4,     3,     3,     1,     1,     2,     3,     2,     1,     1,
       2,     1,     3,     1,     1,     4,     5,     5,     6,     2,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     3,     4,     3,     4,     4,     3,
       4,     1,     2,     2,     3,     1,     1,     1,     3,     2,
       2,     4,     2,     1,     1,     2,     1,     1,     2,     1,
       2,     3,     2,     3,     3,     4,     2,     3,     3,     4,
       1,     3,     4,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     4,
       3,     1,     1,     2,     3,     1,     2,     1,     2,     5,
       7,     5,     7,     5,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     5,
       4,     1,     3,     1,     1,     5,     5,     7,     7,     6,
       7,     6,     7,     0,     6,     0,     6,     0,     6,     0,
       8,     1,     3,     2,     2,     2,     3,     2,     3,     4,
       5,     7,     7,     1,     2,     2,     1,     5,     5,     1,
       1,     0,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2:
#line 265 "src/parse.yy"
                           { (yyval.stringVal) = new std::string(*yylval.stringVal); }
#line 2727 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 3:
#line 267 "src/parse.yy"
    {
        std::string s = *((std::string *)(yyvsp[-1].stringVal));
        s += *yylval.stringVal;
        (yyval.stringVal) = new std::string(s);
    }
#line 2737 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 4:
#line 275 "src/parse.yy"
                       {
        const char *name = yylval.stringVal->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = NULL;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, (yylsp[0]));
        }
        if ((yyval.expr) == NULL) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
    }
#line 2761 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 5:
#line 294 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 2770 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 6:
#line 298 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 2779 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 7:
#line 302 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 2788 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 8:
#line 306 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 2797 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 9:
#line 310 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 2806 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 10:
#line 314 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 2815 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 11:
#line 318 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 2824 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 12:
#line 322 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 2833 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 13:
#line 326 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           yylval.floatVal, (yylsp[0]));
    }
#line 2842 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 14:
#line 330 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           yylval.doubleVal, (yylsp[0]));
    }
#line 2851 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 15:
#line 334 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 2859 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 16:
#line 337 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 2867 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 17:
#line 340 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 2875 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 18:
#line 345 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 2881 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 19:
#line 346 "src/parse.yy"
                    { (yyval.expr) = NULL; }
#line 2887 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 20:
#line 351 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 2897 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 21:
#line 357 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 2907 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 22:
#line 364 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 2917 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 23:
#line 370 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 2927 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 24:
#line 377 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 2937 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 25:
#line 383 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 2947 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 26:
#line 389 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 2957 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 27:
#line 395 "src/parse.yy"
      { 
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 2967 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 28:
#line 402 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 2976 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 29:
#line 407 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 2985 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 30:
#line 412 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 2994 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 31:
#line 417 "src/parse.yy"
      { 
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 3003 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 32:
#line 424 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3013 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 33:
#line 430 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3023 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 34:
#line 436 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3033 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 35:
#line 442 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = NULL;
       }
#line 3043 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 37:
#line 452 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 3049 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 38:
#line 454 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3055 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 40:
#line 457 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false); }
#line 3061 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 41:
#line 459 "src/parse.yy"
      { (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true); }
#line 3067 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 42:
#line 461 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3073 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 43:
#line 463 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 3079 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 45:
#line 469 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 3085 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 46:
#line 471 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 3091 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 47:
#line 473 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 3097 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 48:
#line 477 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 3103 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 49:
#line 479 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 3118 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 51:
#line 494 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3124 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 52:
#line 496 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3130 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 53:
#line 498 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3136 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 54:
#line 500 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3142 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 55:
#line 502 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 3148 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 56:
#line 504 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3154 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 57:
#line 506 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3160 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 58:
#line 508 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3166 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 59:
#line 510 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 3172 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 60:
#line 512 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 3178 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 62:
#line 518 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 3186 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 64:
#line 526 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3192 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 65:
#line 528 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3198 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 66:
#line 530 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3204 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 68:
#line 536 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3210 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 69:
#line 538 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3216 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 71:
#line 544 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3222 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 72:
#line 546 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3228 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 74:
#line 552 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3234 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 75:
#line 554 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3240 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 76:
#line 556 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3246 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 77:
#line 558 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3252 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 79:
#line 564 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3258 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 80:
#line 566 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 3264 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 82:
#line 572 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3270 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 84:
#line 578 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3276 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 86:
#line 584 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3282 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 88:
#line 590 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3288 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 90:
#line 596 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3294 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 92:
#line 602 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 3300 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 93:
#line 606 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 3306 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 94:
#line 607 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 3312 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 95:
#line 608 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 3318 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 96:
#line 612 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 3324 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 97:
#line 614 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 3339 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 98:
#line 625 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = NULL;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 3354 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 99:
#line 636 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.type) = NULL;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == NULL) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = NULL;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = NULL;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 3379 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 101:
#line 661 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), NULL, NULL, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 3387 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 102:
#line 665 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), NULL, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 3395 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 103:
#line 669 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), NULL, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 3403 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 105:
#line 677 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3409 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 106:
#line 679 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3415 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 107:
#line 681 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3421 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 108:
#line 683 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3427 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 109:
#line 685 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3433 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 110:
#line 687 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3439 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 111:
#line 689 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3445 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 112:
#line 691 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3451 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 113:
#line 693 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3457 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 114:
#line 695 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3463 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 115:
#line 697 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3469 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 117:
#line 703 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 3475 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 119:
#line 712 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == NULL) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = NULL;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass == SC_TYPEDEF) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == NULL)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = NULL;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 3502 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 120:
#line 738 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 3510 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 121:
#line 742 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
      }
#line 3518 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 122:
#line 749 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 3524 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 123:
#line 754 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yylval.stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
    }
#line 3535 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 124:
#line 764 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
    }
#line 3544 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 125:
#line 769 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != NULL)
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 3554 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 126:
#line 778 "src/parse.yy"
    {
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 3562 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 127:
#line 785 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, (yyvsp[0].storageClass));
      }
#line 3570 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 128:
#line 789 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->storageClass != SC_NONE)
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        lGetStorageClassString(ds->storageClass),
                        lGetStorageClassString((yyvsp[-1].storageClass)));
              else
                  ds->storageClass = (yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
      }
#line 3588 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 129:
#line 803 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != NULL)
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
      }
#line 3598 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 130:
#line 809 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != NULL && declSpecList != NULL) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);
          }
          (yyval.declSpecs) = ds;
      }
#line 3612 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 131:
#line 819 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 3622 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 132:
#line 825 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 3637 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 133:
#line 836 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 3645 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 134:
#line 840 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 3655 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 135:
#line 846 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL) {
              if (ds->baseType != NULL) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  }
                  else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 3677 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 136:
#line 864 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(NULL, SC_NONE, (yyvsp[0].typeQualifier));
      }
#line 3685 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 137:
#line 868 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != NULL)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 3696 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 138:
#line 878 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3707 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 139:
#line 885 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 3722 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 141:
#line 900 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 3732 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 142:
#line 908 "src/parse.yy"
                    { (yyval.storageClass) = SC_TYPEDEF; }
#line 3738 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 143:
#line 909 "src/parse.yy"
                   { (yyval.storageClass) = SC_EXTERN; }
#line 3744 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 144:
#line 910 "src/parse.yy"
                                           { (yyval.storageClass) = SC_EXTERN_C; }
#line 3750 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 145:
#line 911 "src/parse.yy"
                   { (yyval.storageClass) = SC_STATIC; }
#line 3756 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 146:
#line 915 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].atomicType); }
#line 3762 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 147:
#line 917 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
    }
#line 3771 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 148:
#line 921 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 3777 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 149:
#line 922 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 3783 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 150:
#line 927 "src/parse.yy"
    {
        if ((yyvsp[0].type) == NULL)
            (yyval.typeList) = NULL;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 3798 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 151:
#line 938 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == NULL)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 3810 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 152:
#line 948 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::Void; }
#line 3816 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 153:
#line 949 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 3822 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 154:
#line 950 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 3828 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 155:
#line 951 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 3834 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 156:
#line 952 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 3840 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 157:
#line 953 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 3846 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 158:
#line 954 "src/parse.yy"
                { (yyval.atomicType) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 3852 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 159:
#line 955 "src/parse.yy"
                 { (yyval.atomicType) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 3858 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 160:
#line 956 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 3864 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 161:
#line 957 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 3870 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 162:
#line 958 "src/parse.yy"
                  { (yyval.atomicType) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 3876 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 163:
#line 959 "src/parse.yy"
                   { (yyval.atomicType) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 3882 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 164:
#line 964 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].atomicType) ? new VectorType((yyvsp[-3].atomicType), (int32_t)(yyvsp[-1].intVal)) : NULL;
    }
#line 3890 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 165:
#line 970 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 3896 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 166:
#line 971 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 3902 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 167:
#line 976 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == NULL) {
              st = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              m->symbolTable->AddType((yyvsp[0].constCharPtr), st, (yylsp[0]));
              (yyval.type) = st;
          }
          else {
              if (CastType<StructType>(st) == NULL &&
                  CastType<UndefinedStructType>(st) == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = NULL;
              }
              else
                  (yyval.type) = st;
         }
      }
#line 3925 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 169:
#line 999 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ?
                  CastType<StructType>((yyvsp[-3].type))->GetStructName() :
                  CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              StructType *st = new StructType(name, elementTypes, elementNames,
                                              elementPositions, false, Variability::Unbound, (yylsp[-3]));
              m->symbolTable->AddType(name.c_str(), st, (yylsp[-3]));
              (yyval.type) = st;
          }
          else
              (yyval.type) = NULL;
      }
#line 3948 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 170:
#line 1018 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != NULL) {
              llvm::SmallVector<const Type *, 8> elementTypes;
              llvm::SmallVector<std::string, 8> elementNames;
              llvm::SmallVector<SourcePos, 8> elementPositions;
              GetStructTypesNamesPositions(*(yyvsp[-1].structDeclarationList), &elementTypes, &elementNames,
                                           &elementPositions);
              (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                                  false, Variability::Unbound, (yylsp[-3]));
          }
          else
              (yyval.type) = NULL;
      }
#line 3966 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 171:
#line 1032 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          (yyval.type) = new StructType("", elementTypes, elementNames, elementPositions,
                              false, Variability::Unbound, (yylsp[-2]));
      }
#line 3978 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 172:
#line 1040 "src/parse.yy"
      {
          llvm::SmallVector<const Type *, 8> elementTypes;
          llvm::SmallVector<std::string, 8> elementNames;
          llvm::SmallVector<SourcePos, 8> elementPositions;
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ?
              CastType<StructType>((yyvsp[-2].type))->GetStructName() :
              CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          StructType *st = new StructType(name, elementTypes,
                                          elementNames, elementPositions,
                                          false, Variability::Unbound, (yylsp[-2]));
          m->symbolTable->AddType(name.c_str(), st, (yylsp[-1]));
          (yyval.type) = st;
      }
#line 3996 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 174:
#line 1061 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4007 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 175:
#line 1068 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != NULL)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 4022 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 176:
#line 1082 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != NULL && (yyvsp[-1].structDeclaratorList) != NULL) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : NULL; }
#line 4028 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 180:
#line 1090 "src/parse.yy"
    {
        if ((yyvsp[0].type) != NULL) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = NULL;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = NULL;
        }
    }
#line 4104 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 181:
#line 1166 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4115 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 182:
#line 1173 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != NULL)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 4130 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 183:
#line 1186 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 4136 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 184:
#line 1194 "src/parse.yy"
                       { (yyval.constCharPtr) = strdup(yytext); }
#line 4142 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 185:
#line 1198 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4150 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 186:
#line 1202 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
      }
#line 4158 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 187:
#line 1206 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(NULL, (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4166 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 188:
#line 1210 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
      }
#line 4174 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 189:
#line 1214 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == NULL) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = NULL;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == NULL) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = NULL;
              }
              else
                  (yyval.enumType) = enumType;
          }
      }
#line 4198 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 190:
#line 1237 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == NULL)
              (yyval.symbolList) = NULL;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 4212 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 191:
#line 1247 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != NULL)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 4227 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 192:
#line 1261 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]));
      }
#line 4235 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 193:
#line 1265 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].constCharPtr) != NULL && (yyvsp[0].expr) != NULL &&
              lGetConstantInt((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]));
              sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                              (uint32_t)value, (yylsp[0]));
              (yyval.symbol) = sym;
          }
          else
              (yyval.symbol) = NULL;
      }
#line 4252 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 194:
#line 1280 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 4258 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 195:
#line 1281 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 4264 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 196:
#line 1282 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 4270 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 197:
#line 1283 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 4276 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 198:
#line 1284 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 4282 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 199:
#line 1285 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 4288 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 200:
#line 1286 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 4294 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 201:
#line 1287 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 4300 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 202:
#line 1288 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 4306 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 203:
#line 1289 "src/parse.yy"
                       { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 4312 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 204:
#line 1294 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 4320 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 205:
#line 1298 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 4328 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 206:
#line 1305 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4344 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 207:
#line 1317 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != NULL) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != NULL)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4360 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 209:
#line 1332 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 4366 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 210:
#line 1333 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4372 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 211:
#line 1334 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4378 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 212:
#line 1335 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 4384 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 213:
#line 1340 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
      }
#line 4394 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 214:
#line 1346 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 4402 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 215:
#line 1350 "src/parse.yy"
    {
        int size;
        if ((yyvsp[-3].declarator) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = size;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4424 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 216:
#line 1368 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = NULL;
    }
#line 4439 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 217:
#line 1379 "src/parse.yy"
    {
         (yyval.declarator) = NULL;
    }
#line 4447 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 218:
#line 1383 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL)
                  d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4463 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 219:
#line 1395 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != NULL) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4477 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 220:
#line 1405 "src/parse.yy"
    {
        (yyval.declarator) = NULL;
    }
#line 4485 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 221:
#line 1413 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 4493 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 222:
#line 1417 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 4503 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 223:
#line 1423 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4513 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 224:
#line 1429 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 4524 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 225:
#line 1440 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 4532 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 226:
#line 1447 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 4538 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 227:
#line 1452 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4549 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 228:
#line 1459 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == NULL)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != NULL)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 4562 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 229:
#line 1468 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = NULL;
    }
#line 4571 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 230:
#line 1476 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 4579 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 231:
#line 1480 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != NULL && (yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = NULL;
    }
#line 4592 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 232:
#line 1489 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != NULL && (yyvsp[0].declarator) != NULL)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = NULL;
    }
#line 4603 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 233:
#line 1496 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == NULL)
            (yyval.declaration) = NULL;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 4614 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 235:
#line 1514 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == NULL || (yyvsp[0].declarator) == NULL)
            (yyval.type) = NULL;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), NULL);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 4627 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 236:
#line 1526 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 4635 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 238:
#line 1531 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4649 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 239:
#line 1541 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 4657 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 240:
#line 1545 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4671 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 241:
#line 1558 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 4677 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 242:
#line 1560 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 4687 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 243:
#line 1566 "src/parse.yy"
      {
        int size;
        if ((yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            if (size < 0) {
                Error((yylsp[-1]), "Array dimension must be non-negative.");
                (yyval.declarator) = NULL;
            }
            else {
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = size;
                (yyval.declarator) = d;
            }
        }
        else
            (yyval.declarator) = NULL;
      }
#line 4708 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 244:
#line 1583 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4723 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 245:
#line 1594 "src/parse.yy"
      {
          int size;
          if ((yyvsp[-3].declarator) != NULL && (yyvsp[-1].expr) != NULL && lGetConstantInt((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              if (size < 0) {
                  Error((yylsp[-1]), "Array dimension must be non-negative.");
                  (yyval.declarator) = NULL;
              }
              else {
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = size;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              }
          }
          else
              (yyval.declarator) = NULL;
      }
#line 4745 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 246:
#line 1612 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 4751 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 247:
#line 1614 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
          (yyval.declarator) = d;
      }
#line 4761 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 248:
#line 1620 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 4775 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 249:
#line 1630 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == NULL)
              (yyval.declarator) = NULL;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != NULL) d->functionParams = *(yyvsp[-1].declarationList);
              (yyval.declarator) = d;
          }
      }
#line 4790 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 251:
#line 1644 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 4796 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 252:
#line 1645 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 4802 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 253:
#line 1650 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 4808 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 254:
#line 1652 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == NULL) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 4823 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 267:
#line 1678 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = NULL;
    }
#line 4832 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 268:
#line 1686 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
    }
#line 4840 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 269:
#line 1690 "src/parse.yy"
      {
          int value;
          if ((yyvsp[-2].expr) != NULL &&
              lGetConstantInt((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              (yyval.stmt) = new CaseStmt(value, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
          }
          else
              (yyval.stmt) = NULL;
      }
#line 4854 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 270:
#line 1700 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 4860 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 271:
#line 1704 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 4866 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 272:
#line 1708 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 4872 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 273:
#line 1712 "src/parse.yy"
              { (yyval.stmt) = NULL; }
#line 4878 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 274:
#line 1713 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 4884 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 275:
#line 1718 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 4894 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 276:
#line 1724 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == NULL) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 4908 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 277:
#line 1736 "src/parse.yy"
          { (yyval.stmt) = NULL; }
#line 4914 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 278:
#line 1737 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : NULL; }
#line 4920 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 279:
#line 1742 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, false, (yylsp[-4])); }
#line 4926 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 280:
#line 1744 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 4932 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 281:
#line 1746 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), NULL, true, (yylsp[-4])); }
#line 4938 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 282:
#line 1748 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 4944 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 283:
#line 1750 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 4950 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 284:
#line 1755 "src/parse.yy"
      { (yyval.expr) = NULL; }
#line 4956 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 285:
#line 1757 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 4962 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 288:
#line 1766 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 4968 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 289:
#line 1770 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 4974 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 290:
#line 1774 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 4980 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 291:
#line 1778 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 4986 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 292:
#line 1783 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::VaryingInt32->GetAsConstType());
    }
#line 4994 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 293:
#line 1789 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5000 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 294:
#line 1794 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), AtomicType::UniformInt64->GetAsConstType());
    }
#line 5008 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 295:
#line 1800 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 5017 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 296:
#line 1804 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 5026 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 297:
#line 1808 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 5035 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 298:
#line 1812 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 5044 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 299:
#line 1820 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 5052 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 300:
#line 1824 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 5060 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 301:
#line 1831 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 5069 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 302:
#line 1836 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == NULL) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != NULL)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 5084 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 303:
#line 1849 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 5090 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 304:
#line 1853 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5096 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 305:
#line 1858 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 5102 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 306:
#line 1860 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(NULL, (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 5108 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 307:
#line 1862 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 5114 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 308:
#line 1864 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 5120 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 309:
#line 1866 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5128 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 310:
#line 1870 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5136 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 311:
#line 1874 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), NULL, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 5144 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 312:
#line 1878 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 5152 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 313:
#line 1882 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5166 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 314:
#line 1892 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5188 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 315:
#line 1910 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 5203 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 316:
#line 1921 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == NULL) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();
     }
#line 5225 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 317:
#line 1939 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != NULL)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 5234 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 318:
#line 1944 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 5243 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 319:
#line 1950 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != NULL &&
             (expr = TypeCheck(expr)) != NULL &&
             (type = expr->GetType()) != NULL) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 5259 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 320:
#line 1962 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();
     }
#line 5268 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 321:
#line 1969 "src/parse.yy"
                       { (yyval.constCharPtr) = yylval.stringVal->c_str(); }
#line 5274 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 322:
#line 1974 "src/parse.yy"
      { (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1])); }
#line 5280 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 323:
#line 1976 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 5286 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 324:
#line 1978 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 5292 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 325:
#line 1980 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(NULL, (yylsp[-1])); }
#line 5298 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 326:
#line 1982 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 5304 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 327:
#line 1987 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 5310 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 328:
#line 1992 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 5318 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 329:
#line 1999 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 5326 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 330:
#line 2006 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), NULL, (yylsp[-4]));
      }
#line 5334 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 331:
#line 2010 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
      }
#line 5342 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 332:
#line 2017 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
      }
#line 5350 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 338:
#line 2032 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != NULL)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 5359 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 339:
#line 2037 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != NULL)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 5369 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 341:
#line 2047 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 5381 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;

  case 342:
#line 2055 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != NULL) {
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == NULL)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass == SC_TYPEDEF)
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == NULL) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 5402 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"
    break;


#line 5406 "/builddir/build/BUILD/ispc-1.13.0/build/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2081 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}


static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == NULL)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == NULL || decl == NULL)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass == SC_TYPEDEF)
        m->AddTypeDef(decl->name, decl->type, decl->pos);
    else {
        if (decl->type == NULL) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != NULL) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass,
                                      isInline, isNoInline, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl->name, decl->type, decl->initExpr,
                                 isConst, decl->storageClass, decl->pos);
        }
    }
}


/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    m->symbolTable->PushScope();

    if (decl == NULL) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != NULL)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != NULL && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == NULL)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos,
                                     declarator->type, declarator->storageClass);
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = NULL;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, type);
    m->symbolTable->AddVariable(taskIndexSym);
    
    Symbol *taskCountSym = new Symbol("taskCount", pos, type);
    m->symbolTable->AddVariable(taskCountSym);
    
    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, type);
    m->symbolTable->AddVariable(taskIndexSym2);

    
    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}

static const char *
lGetStorageClassString(StorageClass sc) {
    switch (sc) {
    case SC_NONE:
        return "";
    case SC_EXTERN:
        return "extern";
    case SC_STATIC:
        return "static";
    case SC_TYPEDEF:
        return "typedef";
    case SC_EXTERN_C:
        return "extern \"C\"";
    default:
        Assert(!"logic error in lGetStorageClassString()");
        return "";
    }
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantInt(Expr *expr, int *value, SourcePos pos, const char *usage) {
    if (expr == NULL)
        return false;
    expr = TypeCheck(expr);
    if (expr == NULL)
        return false;
    expr = Optimize(expr);
    if (expr == NULL)
        return false;

    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == NULL) {
        Error(pos, "%s must be a compile-time constant.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == NULL) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        if (type->IsUnsignedType())
            *value = (int)ci->getZExtValue();
        else
            *value = (int)ci->getSExtValue();
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == NULL)
        return NULL;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != NULL)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}


/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    enumType = enumType->GetAsConstType();
    enumType = enumType->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = enumType;
        if (enums[i]->constValue != NULL) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(enumType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != NULL);
        }
        else {
            enums[i]->constValue = new ConstExpr(enumType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
